=begin
Jeu de cases utilisant la bibliothque Tk
=end

require 'tk'

##### CREATION DE LA CLASSE
class Cases

    ### Constantes de positionnement des widgets
    X0=30
    Y0=40
    LARGEUR=50
    HAUTEUR=60
    ECARTH=10
    ECARTV=20

    ETEINT="#ff8000"
    ALLUME="green"
    
    ### Initialisation de la classe (widgets et variables)
    def initialize()
        # Fenetre principale
	@wa=TkRoot.new 
        @wa.title="Jeu des cases"
        @wa.height=300
        @wa.configure("width" => "300") 
	 
        # Tableau des boutons
	# ... Boutons lis
	@tblien=[ \
	    " ", \
	    "124", \
	    "123", \
	    "236", \
	    "147", \
	    "24685", \
	    "369", \
	    "478", \
	    "789", \
	    "689"  \
	    ]

	@tbt=[]
	(1..9).each {|i|
            (l, c)= calc_lc(i)
            x=X0 + c * (LARGEUR + ECARTH)
            y=Y0 + l * (HAUTEUR + ECARTV)
            @tbt[i]= 
	        TkButton.new(@wa) {
                    text "#{i}"
                    place("x"=>x, "y"=>y, 'height'=>HAUTEUR, 'width'=>LARGEUR)
		    #command proc {trt_bout(i)} #procedure non reconnue
                }
		@tbt[i].command proc {trt_bout(i)}
	}

        # Bouton "nouveau jeu"
        x=X0 + 3 * (LARGEUR + ECARTH)
        y=Y0 
        btnew=TkButton.new(@wa) {
                    text "Nouveau"
                    place("x"=>x, "y"=>y)
                }
		btnew.command proc {nouveau_jeu}
	
	# Score
        x=X0 + 3 * (LARGEUR + ECARTH)
        y=Y0 + 1 * (HAUTEUR + ECARTV)
	TkLabel.new(@wa) {
	    text "Score"
	    justify "center"
	    place("x"=>x, "y"=>y, "width"=>2*LARGEUR)
	    }

	@txscore=TkLabel.new(@wa) {
	    text " "		
	     justify "center"
	     font('size'=>14, "weight"=>'bold')
	     place("x"=>x, "y"=>y+20, "width"=>2*LARGEUR)
	    }

	# Tirage initial
	nouveau_jeu

    end

    # Calcul des lignes/colonnes en fonction du n de bouton
    def calc_lc(i)
        return [0,0,0,1,1,1,2,2,2][i-1], [0,1,2,0,1,2,0,1,2][i-1]
    end

    ### Tirage alatoire des boutons
    def tirage()
	@val=[" "]
	(1..9).each {|i|
	    @val[i]=rand(2)
	    }
    end

    ### Affichage des boutons
    def afficher_boutons()
	(1..9).each {|i|
	    aff_1_bouton(i)
	}
    end

    ### Affichage d'un bouton
    def aff_1_bouton(i)
	if @val[i]==0
	    @tbt[i].background=ETEINT
	else	    
	    @tbt[i].background=ALLUME
	end 
    end

    ### Traitement d'un bouton
    def trt_bout(b)
	# recuperer les boutons lis
	@tblien[b].each_char {|x|
	    y=x.to_i
	    # inverser
	    @val[y] = 1 - @val[y]
            aff_1_bouton(y)
	    }
	# incrmenter le score
	@score = @score+1
	afficher_score

        # verif si gagne
        if @val == [" ", 1,1,1,1,0,1,1,1,1]
	    Tk.messageBox(
                'type'    => "ok",  
                'icon'    => "info", 
                'title'   => "GAGNE !",
                'message' => "Bravo ! en #{@score} coup(s)"
                )
	    nouveau_jeu
	end

    end
    
    ### Affichage du score
    def afficher_score()
	@txscore.text = @score.to_s
    end

    ### Nouveau jeu
    def nouveau_jeu()
    	tirage
	@score=0
	afficher_boutons
	afficher_score
    end

end


##### PROCEDURE PRINCIPALE
obj=Cases.new()
Tk.mainloop
