=begin
Ce programme opre sur des rpertoires et des fichiers
Cration , criture, ajout, modification, suppression ...
=end

require 'fileutils' # module avec quelques outils fichiers (copie, ...)



### Procdure rcursive de suppression d'un  dossier
# remplac par FileUtils.remove_dir(path)

def suppr_dossier(pdos)

    # lister le dossier
    (Dir.entries(pdos) - [".", ".."]).each {|nomfic|

	# sous-dossier -> supprimer sous-sous-dossiers
	if File.ftype(pdos+"/"+nomfic) == "directory"
	    suppr_dossier(pdos+"/"+nomfic)
        
	# fichier -> supprimer
	else
	    File.delete(pdos+"/"+nomfic)
	end
	}
    
    #  la fin supprimer le dossier de dpart
    Dir.delete(pdos)

end





### Supprimer le rpertoire de test s'il existe
racine="x:\\temp\\rubytest"

if Dir.exists?(racine)
    puts "Suppression du dossier"
    suppr_dossier(racine)
end

### Crer le rpertoire et deux sous dossiers
Dir.mkdir(racine) 
Dir.mkdir(racine+"/d1")         # cre le dossier
d1=Dir.new(racine+"/d1")        # affecte une variable au dossier
d11=Dir.mkdir(racine+"/d1/d11") # cre le dossier et la variable est le rsultat de la cde, pas une affectation
Dir.mkdir(racine+"\\d2")
d2=Dir.new(racine+"\\d2")

### Compter le nombre de sous-dossiers directs (pas de fichiers)
dr=Dir.new(racine) # aprs avoir cr les sous-dossiers !
dre=dr.entries - [".", ".."] # ignorer les rpertoires parents
nbd=dre.length
puts "Nombre de sous-dossiers = #{nbd}"
dre.each { |nomsdo|
           puts "   sous-dossier : #{nomsdo} = #{File.absolute_path(nomsdo, dr.path)}"
	 }

### Crer un fichier
f1=File.open(d1.path+"/f1.txt", "w")
f1.write("Ligne 1\n")
f1.write("Ligne 5\n")
f1.close

# Ajouter une ligne
f1=File.open(d1.path+"/f1.txt", "a")
f1.write("Ligne 3\n")
f1.close

# Modification    comment ouvrir mode binaire ????
#f1=IO.new(d1.path+"/f1.txt", "rb")
#f1.close

### Lire un fichier
puts "Lecture avec each_line"
f1=File.open(d1.path+"/f1.txt", "r")
f1.each_line { |ligne|
  puts "   #{ligne}"
}
f1.close

# ou (utilisation de tableau en mmoire) : le fichier reste verrouill !!!
#puts "Lecture avec readlines en tableau"
#File.open(d1.path+"/f1.txt", "r", autossssss:true).readlines.each { |ligne| # readlines hrit de IO)
#  puts "   #{ligne}"
#}
#File.open(d1.path+"/f1.txt", "r").flock(File::LOCK_UN)

### Copie du fichier
dest=f1.path
dest["/d1"]="/d2" # remplace /d1 par /d2
FileUtils.cp f1.path, dest

